#version 400

uniform sampler2D texSampler0;
uniform sampler2D texSampler1;
uniform vec2 pixelSize;

in vec2 varTexCoords;

out vec4 fragColor;

float mixDepth(float original, float depth, vec2 texCoord)
{
	// used to counter "halo" around objects
	const float ssaoFocus = 0.5;
	return mix(texture2D(texSampler0, texCoord).r, original, clamp((depth - texture2D(texSampler1, texCoord).a)/ssaoFocus,0.0,1.0));
}

void main()
{
	float depth = texture2D(texSampler1, varTexCoords).a;

    vec2 offset1 = vec2(pixelSize.x,		0.0);
    vec2 offset2 = vec2(pixelSize.x * 2.0,	0.0);
    vec2 offset3 = vec2(pixelSize.x * 3.0,	0.0);

	float original = texture2D(texSampler0, varTexCoords).r;

	float left1 = mixDepth(original, depth, varTexCoords - offset1);//texture2D(texSampler0, varTexCoords - offset1);
	float left2 = mixDepth(original, depth, varTexCoords - offset2);//texture2D(texSampler0, varTexCoords - offset2);
	float left3 = mixDepth(original, depth, varTexCoords - offset3);//texture2D(texSampler0, varTexCoords - offset3);
	
	float right1 = mixDepth(original, depth, varTexCoords + offset1);//texture2D(texSampler0, varTexCoords + offset1);
	float right2 = mixDepth(original, depth, varTexCoords + offset2);//texture2D(texSampler0, varTexCoords + offset2);
	float right3 = mixDepth(original, depth, varTexCoords + offset3);//texture2D(texSampler0, varTexCoords + offset3);

	float c = (left1 + left2 + left3 + original + right1 + right2 + right3)/7.0;
	fragColor = vec4(c,c,c,1.0);
}