#version 400

uniform sampler2D texSampler0;
uniform sampler2D texSampler1;
uniform vec2 pixelSize;

in vec2 varTexCoords;

out vec4 fragColor;

float mixDepth(float original, float depth, vec2 texCoord)
{
	// used to counter "halo" around objects
	const float ssaoFocus = 0.5;
	return mix(texture2D(texSampler0, texCoord).r, original, clamp((depth - texture2D(texSampler1, texCoord).a)/ssaoFocus,0.0,1.0));
}


void main()
{
	float depth = texture2D(texSampler1, varTexCoords).a;

    vec2 offset1 = vec2(0.0, pixelSize.y);
    vec2 offset2 = vec2(0.0, pixelSize.y * 2.0);
    vec2 offset3 = vec2(0.0, pixelSize.y * 3.0);

	float original = texture2D(texSampler0, varTexCoords).r;

	float bot1 = mixDepth(original, depth, varTexCoords - offset1);//texture2D(texSampler0, varTexCoords - offset1);
	float bot2 = mixDepth(original, depth, varTexCoords - offset2);//texture2D(texSampler0, varTexCoords - offset2);
	float bot3 = mixDepth(original, depth, varTexCoords - offset3);//texture2D(texSampler0, varTexCoords - offset3);

	float top1 = mixDepth(original, depth, varTexCoords + offset1);//texture2D(texSampler0, varTexCoords + offset1);
	float top2 = mixDepth(original, depth, varTexCoords + offset2);//texture2D(texSampler0, varTexCoords + offset2);
	float top3 = mixDepth(original, depth, varTexCoords + offset3);//texture2D(texSampler0, varTexCoords + offset3);

	float c = (bot1 + bot2 + bot3 + original + top1 + top2 + top3)/7.0;
	fragColor = vec4(c,c,c,1.0);
}