#version 400

uniform mat4 pvmtMatrix;

uniform mat4 vmtMatrix;
uniform mat4 vmtInvTranspMatrix;

uniform float near;
uniform float far;

layout (location = 0) in vec4 vertexPosition; 
layout (location = 2) in vec4 vertexNormal;

out vec3 varNormal;   ///< vertex normal in viewing-space
out float depth;

void main()
{	
	varNormal = normalize(mat3(vmtInvTranspMatrix) * vertexNormal.xyz);
	varNormal = varNormal * 0.5 + 0.5;
	
	vec4 viewSpacePos = vmtMatrix * vertexPosition;
	
    depth = (-viewSpacePos.z-near)/(far-near); // will map near..far to 0..1

	gl_Position = pvmtMatrix * vertexPosition;
}
