#version 400

uniform mat4 projectionMatrix;
uniform mat4 pvmtMatrix;
uniform mat4 modelMatrix;
uniform mat4 vmtMatrix;
uniform mat3 normalMatrix;
uniform mat4 textureModelMatrix; // texture matrix * model matrix (tex mat : m_textureMatrix * m_lightPerspective * m_lightView;)
uniform mat4 dirLightTextureModelMatrix;  // texture matrix * model matrix (tex mat : m_textureMatrix * m_lightPerspective * m_lightView;)
uniform mat4 spotLightTextureModelMatrix0; // texture matrix * model matrix (tex mat : m_textureMatrix * m_lightPerspective * m_lightView;)
uniform mat4 spotLightTextureModelMatrix1; // texture matrix * model matrix (tex mat : m_textureMatrix * m_lightPerspective * m_lightView;)

layout (location = 0) in vec4 vertexPosition; 
layout (location = 1) in vec2 vertexTexCoord;
layout (location = 2) in vec3 vertexNormal;

out vec2 varTexCoords;
out vec4 varDirLightShadowMapTexCoords;
out vec4 varSpotLightShadowMapTexCoords0;
out vec4 varSpotLightShadowMapTexCoords1;
out vec3 varPositionVS; ///< vertex position in viewing-space
out vec3 varNormalVS;   ///< vertex normal in viewing-space

void main()
{	
	varNormalVS = normalMatrix * vertexNormal;
	varTexCoords = vertexTexCoord;
	varPositionVS = (vmtMatrix * vertexPosition).xyz;

	varDirLightShadowMapTexCoords = dirLightTextureModelMatrix * vertexPosition;
	varSpotLightShadowMapTexCoords0 = spotLightTextureModelMatrix0 * vertexPosition;
	varSpotLightShadowMapTexCoords1 = spotLightTextureModelMatrix1 * vertexPosition;

	gl_Position = pvmtMatrix * vertexPosition;
}
