#version 400 core

uniform mat4 viewMatrix;
uniform mat4 projMatrix;

layout (location = 0) in vec4 vertexPosition;
layout (location = 10) in vec3 vertexParam0; ///< front vector, must be normalized
layout (location = 11) in vec3 vertexParam1; ///< up vector, must be normalized
// the side vector will be the front x up

out vec3 varFront;
out vec3 varUp;
out vec3 varSide; 

void main(void) 
{
	varFront = normalize(vertexParam0);
	varUp = normalize(vertexParam1);
	varSide = cross(varFront, varUp);

	// transform vertex to world space
	gl_Position = vertexPosition;
}