#version 330 core

uniform mat4 mtMatrix; //model matrix (passed per object)
uniform mat4 projectionMatrix;
uniform mat4 pvmtMatrix;
uniform mat4 modelMatrix;
uniform mat4 vmtMatrix;
uniform mat3 normalMatrix;
uniform mat4 textureModelMatrix; // texture matrix * model matrix (tex mat : m_textureMatrix * m_lightPerspective * m_lightView;)
uniform mat4 dirLightTextureModelMatrix;  // texture matrix * model matrix (tex mat : m_textureMatrix * m_lightPerspective * m_lightView;)
uniform mat4 spotLightTextureModelMatrix0; // texture matrix * model matrix (tex mat : m_textureMatrix * m_lightPerspective * m_lightView;)
uniform mat4 spotLightTextureModelMatrix1; // texture matrix * model matrix (tex mat : m_textureMatrix * m_lightPerspective * m_lightView;)

out vec2 geoTexCoords;
out vec4 geoDirLightShadowMapTexCoords;
out vec4 geoSpotLightShadowMapTexCoords0;
out vec4 geoSpotLightShadowMapTexCoords1;
out vec3 geoPositionVS; ///< vertex position in viewing-space
out vec3 geoNormalVS;   ///< vertex normal in viewing-space

layout (location = 0) in vec4 vertexPosition;
layout (location = 1) in vec2 vertexTexCoord;
layout (location = 2) in vec3 vertexNormal;

void main(void) 
{
	geoTexCoords = vertexTexCoord;

	geoNormalVS = normalMatrix * vertexNormal;
	geoTexCoords = vertexTexCoord;
	geoPositionVS = (vmtMatrix * vertexPosition).xyz;

	geoDirLightShadowMapTexCoords = dirLightTextureModelMatrix * vertexPosition;
	geoSpotLightShadowMapTexCoords0 = spotLightTextureModelMatrix0 * vertexPosition;
	geoSpotLightShadowMapTexCoords1 = spotLightTextureModelMatrix1 * vertexPosition;

	// transform vertex to world space
	gl_Position = mtMatrix * vertexPosition;

}