#version 400 core

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projMatrix;
// textureModelMatrix only used in the geometry shader

uniform float time;

layout (location = 0) in vec4 vertexPosition;
layout (location = 10) in float vertexParam0;
layout (location = 11) in float vertexParam1;

out float varSize;
out float varMass;

void main(void) 
{
	varSize = vertexParam0;
	varMass = vertexParam1;

	// dust particles fall down (slowly)
	vec4 pos = modelMatrix * vertexPosition - vec4(0.0, varSize * varMass * time, 0.0, 0.0);
	
	// transform vertex to world space
	gl_Position = pos;
}