#version 400

uniform mat4 pMat;
uniform mat4 viewMat;
uniform vec3 effectOrigin;

layout (location = 0) in vec4 vertexPosition; 
layout (location = 1) in vec2 vertexTexCoord;

out vec2 varTexCoords;
out vec2 varCenter; 

void main()
{	
	varTexCoords = vertexTexCoord;
	vec4 vpos = viewMat * vec4(effectOrigin,1.0);
	varCenter = (vpos.xy/vpos.w) * 0.5 + 0.5;
	gl_Position = pMat * vertexPosition;
}
