#version 400

uniform sampler2D texSampler0;
uniform sampler2D rndTexSampler;
uniform sampler2D heatMaskTexSampler;
uniform vec4 color;
uniform float time;
uniform float effectScale;
uniform float aspectRatio;

in vec2 varTexCoords;

out vec4 fragColor;


void main()
{
	vec4 mask = texture2D(heatMaskTexSampler, varTexCoords);
	vec2 offsetCoords = vec2(varTexCoords.x * effectScale * aspectRatio, varTexCoords.y * effectScale + time);
	vec4 offset = texture2D(rndTexSampler, offsetCoords);
	const float distAmount = 0.01;
	offset.x = (offset.x - 1.0) * distAmount * mask.r;
	offset.y = (offset.y - 1.0) * distAmount * mask.r;
	fragColor = texture2D(texSampler0, varTexCoords.xy + offset.xy) * color;
}