#version 330 core

//uniform vec2 nearFar; // near and far plane for cm-cams
//uniform vec4 lightPos; // world space light position

in vec4 WS_pos_from_GS;
in vec2 nF; // near and far plane for cm-cams
in vec4 lP;	// world space light position

void main(void) 
{
	// calculate distance
	float WS_dist = distance(WS_pos_from_GS, lP);
	// map value to [0;1] by dividing by far plane distance
	float WS_dist_normalized = WS_dist / nF.y;
	// write modified depth
	gl_FragDepth = WS_dist_normalized;
	// when using depth-only FBO, do NOT write to color!!!
}