#version 400

uniform mat4 pvmtMatrix;
uniform mat4 modelMatrix;
uniform mat4 vmtMatrix;
uniform mat4 normalMatrix;
uniform mat4 vmtInvTranspMatrix;
uniform mat4 textureModelMatrix; // texture matrix * model matrix (tex mat : m_textureMatrix * m_lightPerspective * m_lightView;)

layout (location = 0) in vec4 vertexPosition; 
layout (location = 1) in vec2 vertexTexCoord;
layout (location = 2) in vec3 vertexNormal;

out vec2 varTexCoords;
out vec4 shadowMapTexCoords;
out vec4 varWorldPos;
out vec4 varPositionVS; ///< vertex position in viewing-space
out vec3 varNormalVS;   ///< vertex normal in viewing-space

void main()
{	
	varNormalVS = normalize(mat3(normalMatrix) * normalize(vec3(vertexNormal))); // Passt no net ganz
	varTexCoords = vertexTexCoord;
	shadowMapTexCoords = textureModelMatrix * vertexPosition;
	varWorldPos = modelMatrix * vertexPosition;
	varPositionVS = vmtMatrix * vertexPosition;
	gl_Position = pvmtMatrix * vertexPosition;
}
