#version 400

uniform samplerCube cubeTexSampler;
uniform float matReflectFactor; // The direction of the reflected ray
uniform vec4 matColor; ///< Color of the object's "Tint"


// varyings
in vec3 varReflectDir;

// output-color of fragment
layout(location = 0) out vec4 fragColor;

void main()
{
	vec4 cubeMapColor = texture(cubeTexSampler, varReflectDir);
	fragColor = mix(matColor, cubeMapColor, matReflectFactor);
}