#version 400

uniform mat4 mtMatrix;
uniform mat3 mtNormalMatrix;
uniform mat4 pvmtMatrix;
uniform vec3 cameraPosWS;

layout (location = 0) in vec4 vertexPosition; 
layout (location = 1) in vec2 vertexTexCoord;
layout (location = 2) in vec3 vertexNormal;

out vec3 varReflectDir;

void main()
{	
	// compute the reflected direction in world coords
	vec3 posWS = vec3(mtMatrix * vertexPosition);
	vec3 normalWS = mtNormalMatrix * vertexNormal;
	vec3 viewDirWS = normalize(cameraPosWS - posWS);
	varReflectDir = reflect(-viewDirWS, normalWS);

	gl_Position = pvmtMatrix * vertexPosition;
}
