#version 400

uniform samplerCube cubeTexSampler;
uniform float matReflectFactor; // The direction of the reflected ray
uniform vec4 matColor; ///< Color of the object's "Tint"
uniform vec3 cameraPosWS;

// varyings
in vec3 varPosWS;
in vec3 varNormalWS;

// output-color of fragment
layout(location = 0) out vec4 fragColor;

void main()
{

	vec3 viewDirWS = normalize(varPosWS - cameraPosWS);
	
	//vec3 refractDir = refract(viewDirWS, -varNormalWS, 0.5);
	vec3 refractDir = refract(viewDirWS, varNormalWS, 0.5);

	vec4 cubeMapColor = texture(cubeTexSampler, refractDir);

	fragColor = mix(matColor, cubeMapColor, matReflectFactor);
}