#version 400

uniform mat4 projectionMatrix;
uniform mat4 pvmtMatrix;
uniform mat4 modelMatrix;
uniform mat4 vmtMatrix;
uniform mat4 vmtInvTranspMatrix;

layout (location = 0) in vec4 vertexPosition; 
layout (location = 1) in vec2 vertexTexCoord;
layout (location = 2) in vec4 vertexNormal;
layout (location = 3) in vec4 vertexColor;

out vec2 varTexCoords;
out vec4 varPositionVS; ///< vertex position in viewing-space
out vec3 varNormalVS;   ///< vertex normal in viewing-space
out vec4 varColor;

void main()
{	
	varNormalVS = normalize(mat3(vmtInvTranspMatrix) * normalize(vec3(vertexNormal))); // Sollte passen laut normal = gl_NormalMatrix * gl_Normal; -> Fehler ???
	varTexCoords = vertexTexCoord;
	varColor = vertexColor;
	varPositionVS = vmtMatrix * vertexPosition;
	gl_Position = pvmtMatrix * vertexPosition;
}
