#version 400

layout (location = 0) in vec4 vertexPosition; 
layout (location = 2) in vec3 vertexNormal;

uniform mat4 pvmtMatrix;
uniform mat4 vmtMatrix;
uniform mat3 vmtNormalMatrix;

out vec3 varNormalVS;   ///< vertex normal in viewing-space
out vec3 varPositionVS; ///< vertex position in viewing-space

void main()
{
	varNormalVS = vmtNormalMatrix * vertexNormal;
	varPositionVS = (vmtMatrix * vertexPosition).xyz;
	gl_Position = pvmtMatrix * vertexPosition;
}