#version 400 core

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projMatrix;
// textureModelMatrix only used in the geometry shader

layout (location = 0) in vec4 vertexPosition;
layout (location = 10) in float vertexParam0;
layout (location = 11) in float vertexParam1;
layout (location = 12) in float vertexParam2;

out float varSize;
out float varAlpha;
out float varRotation;

void main(void) 
{
	varSize = vertexParam0;
	varAlpha = vertexParam1;
	varRotation = vertexParam2;

	// dust particles fall down (slowly)
	vec4 pos = modelMatrix * vertexPosition;
	
	// transform vertex to world space
	gl_Position = pos;
}