#version 400

uniform mat4 pvmtMatrix;
uniform mat4 vmtMatrix;
uniform mat3 normalMatrix;

layout (location = 0) in vec4 vertexPosition; 
layout (location = 2) in vec3 vertexNormal;

out vec4 varVertexPosition;
out vec3 varPositionVS; ///< vertex position in viewing-space
out vec3 varNormalVS;   ///< vertex normal in viewing-space

void main()
{	
	varVertexPosition = pvmtMatrix * vertexPosition;
	varPositionVS = (vmtMatrix * vertexPosition).xyz;
	varNormalVS = normalMatrix * vertexNormal;
	gl_Position = pvmtMatrix * vertexPosition;
}
